local addonName, zrMM = ...





local function createPlaceholderFrame(name, frame, label, var)
	frame:SetMovable(true)
	frame:ClearAllPoints()
	frame:SetPoint(zrMM.config[var].point, nil, zrMM.config[var].relativePoint, zrMM.config[var].xOfs, zrMM.config[var].yOfs)
	local ph = CreateFrame("frame", name, UIParent)
	ph:SetMovable(true)
	ph:SetBackdrop({bgFile = zrMM.media.flat})
	ph:SetBackdropColor(0,0,0,.75)
	ph:SetSize(frame:GetWidth(),frame:GetHeight())
	ph:SetPoint("CENTER", frame)
	ph:Hide()
	
	ph.text = ph:CreateFontString(nil,"OVERLAY")
	ph.text:SetFontObject("zrMM_FONT_SMALL")
	ph.text:SetTextColor(.4,.6,1)
	ph.text:SetText(label)
	ph.text:SetJustifyH("CENTER")
    ph.text:SetPoint("CENTER", ph, "CENTER", -1, -1)
	
	ph:SetScript('OnMouseDown', function(self, button)
		if (button == "LeftButton") then
			ph:StartMoving()
		end
	end)
	
	ph:SetScript('OnMouseUp', function(self, button)
		if (button == "LeftButton") then
			ph:StopMovingOrSizing()
			frame:ClearAllPoints()
			frame:SetPoint(ph:GetPoint())
			zrMM.config[var].point, zrMM.config[var].relativeto, zrMM.config[var].relativePoint, zrMM.config[var].xOfs, zrMM.config[var].yOfs = frame:GetPoint()
		end
	end)
	
	return ph
end

local function setUpdateScript(frame, var)
	frame:SetScript("OnUpdate", function(self, elapsed)
		frame:ClearAllPoints()
		frame:SetPoint(zrMM.config[var].point, nil, zrMM.config[var].relativePoint, zrMM.config[var].xOfs, zrMM.config[var].yOfs)
	end)
end



local function unlockInfoPanels()
	-- CharacterFrame
	CharacterFrame:SetMovable(true)
	CharacterFrame:EnableMouse(true)
	CharacterFrame:RegisterForDrag("LeftButton")
	CharacterFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	CharacterFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	
	--DressUpFrame
	DressUpFrame:SetMovable(true)
	DressUpFrame:EnableMouse(true)
	DressUpFrame:RegisterForDrag("LeftButton")
	DressUpFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	DressUpFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	
	--InspectFrame
	local inspect = CreateFrame("Frame")
	inspect:RegisterEvent("INSPECT_READY")
	inspect:SetScript("OnEvent", function(self, event, ...)
	    InspectFrame:SetMovable(true)
	    InspectFrame:EnableMouse(true)
	    InspectFrame:RegisterForDrag("LeftButton")
	    InspectFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	    InspectFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	
	
	end
	)
	
	--GossipFrame
	GossipFrame:SetMovable(true)
	GossipFrame:EnableMouse(true)
	GossipFrame:RegisterForDrag("LeftButton")
	GossipFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	GossipFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	
	
	--TaxiFrame
	TaxiFrame:SetMovable(true)
	TaxiFrame:EnableMouse(true)
	TaxiFrame:RegisterForDrag("LeftButton")
	TaxiFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	TaxiFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	
	--MailFrame
	MailFrame:SetMovable(true)
	MailFrame:EnableMouse(true)
	MailFrame:RegisterForDrag("LeftButton")
	MailFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	MailFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	--MerchantFrame
	MerchantFrame:SetMovable(true)
	MerchantFrame:EnableMouse(true)
	MerchantFrame:RegisterForDrag("LeftButton")
	MerchantFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	MerchantFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	--OpenMailFrame
	OpenMailFrame:SetMovable(true)
	OpenMailFrame:EnableMouse(true)
	OpenMailFrame:RegisterForDrag("LeftButton")
	OpenMailFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	OpenMailFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	--FriendsFrame
	FriendsFrame:SetMovable(true)
	FriendsFrame:EnableMouse(true)
	FriendsFrame:RegisterForDrag("LeftButton")
	FriendsFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	FriendsFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	--QuestFrame
	QuestFrame:SetMovable(true)
	QuestFrame:EnableMouse(true)
	QuestFrame:RegisterForDrag("LeftButton")
	QuestFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	QuestFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	--QuestLogFrame
	QuestLogFrame:SetMovable(true)
	QuestLogFrame:EnableMouse(true)
	QuestLogFrame:RegisterForDrag("LeftButton")
	QuestLogFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	QuestLogFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	
	--SpellBookFrame
	SpellBookFrame:SetMovable(true)
	SpellBookFrame:EnableMouse(true)
	SpellBookFrame:RegisterForDrag("LeftButton")
	SpellBookFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	SpellBookFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	--TabardFrame
	TabardFrame:SetMovable(true)
	TabardFrame:EnableMouse(true)
	TabardFrame:RegisterForDrag("LeftButton")
	TabardFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	TabardFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	--[[TalentFrame
	TalentFrame:SetMovable(true)
	TalentFrame:EnableMouse(true)
	TalentFrame:RegisterForDrag("LeftButton")
	TalentFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	TalentFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	]]--
	--TradeFrame
	TradeFrame:SetMovable(true)
	TradeFrame:EnableMouse(true)
	TradeFrame:RegisterForDrag("LeftButton")
	TradeFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	TradeFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	--[[
	--ClassTrainerFrame
	ClassTrainerFrame:SetMovable(true)
	ClassTrainerFrame:EnableMouse(true)
	ClassTrainerFrame:RegisterForDrag("LeftButton")
	ClassTrainerFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	ClassTrainerFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	]]
	
	
	--Game Menu Windows----------------
	
	--GameMenuFrame
	GameMenuFrame:SetMovable(true)
	GameMenuFrame:EnableMouse(true)
	GameMenuFrame:RegisterForDrag("LeftButton")
	GameMenuFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	GameMenuFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
	
	--VideoOptionsFrame
	--AudioOptionsFrame
	--InterfaceOptionsFrame
	InterfaceOptionsFrame:SetMovable(true)
	InterfaceOptionsFrame:EnableMouse(true)
	InterfaceOptionsFrame:RegisterForDrag("LeftButton")
	InterfaceOptionsFrame:SetScript("OnDragStart", CharacterFrame.StartMoving)
	InterfaceOptionsFrame:SetScript("OnDragStop", CharacterFrame.StopMovingOrSizing)
end

local function loadECSButton()
	if (IsAddOnLoaded("ExtendedCharacterStats")) then
		zrMM.ECSButton = CreateFrame("Button", "ECSToggleButton", nil, "UIPanelButtonTemplate", 60, 20)
		zrMM.ECSButton:SetParent(CharacterAttributesFrame)
		zrMM.ECSButton:SetText("ECS")
		zrMM.ECSButton:SetPoint("BOTTOMRIGHT", CharacterAttributesFrame, "TOPRIGHT")
		zrMM.ECSButton:SetFrameStrata("HIGH")
		zrMM.ECSButton:SetScript("OnClick", function ()
			ECS_StatsFrame:Show()
		end)
	end
end



function zrMM:loadUITweaks()
	
	unlockInfoPanels()
	loadECSButton()
	
	zrMM.Durability = createPlaceholderFrame("zrDurability", DurabilityFrame, "Durability", "durability")
	setUpdateScript(DurabilityFrame, "durability")
	

	zrMM.Loot1 = createPlaceholderFrame("zrLoot1", GroupLootFrame1, "Loot 1", "loot1")
	setUpdateScript(GroupLootFrame1, "loot1")
	zrMM.Loot2 = createPlaceholderFrame("zrLoot2", GroupLootFrame2, "Loot 2", "loot2")
	setUpdateScript(GroupLootFrame2, "loot2")
	zrMM.Loot3 = createPlaceholderFrame("zrLoot3", GroupLootFrame3, "Loot 3", "loot3")
	setUpdateScript(GroupLootFrame3, "loot3")
	zrMM.Loot4 = createPlaceholderFrame("zrLoot4", GroupLootFrame4, "Loot 4", "loot4")
	setUpdateScript(GroupLootFrame4, "loot4")
	
	
end
